package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type OrgSeason struct {
	api.Api
}

// GetPage 获取OrgSeason列表
// @Summary 获取OrgSeason列表
// @Description 获取OrgSeason列表
// @Tags OrgSeason
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.OrgSeason}} "{"code": 200, "data": [...]}"
// @Router /api/v1/org-season [get]
// @Security Bearer
func (e OrgSeason) GetPage(c *gin.Context) {
    req := dto.OrgSeasonGetPageReq{}
    s := service.OrgSeason{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.OrgSeason, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取OrgSeason 失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取OrgSeason
// @Summary 获取OrgSeason
// @Description 获取OrgSeason
// @Tags OrgSeason
// @Param id path string false "id"
// @Success 200 {object} response.Response{data=models.OrgSeason} "{"code": 200, "data": [...]}"
// @Router /api/v1/org-season/{id} [get]
// @Security Bearer
func (e OrgSeason) Get(c *gin.Context) {
	req := dto.OrgSeasonGetReq{}
	s := service.OrgSeason{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.OrgSeason

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取OrgSeason失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建OrgSeason
// @Summary 创建OrgSeason
// @Description 创建OrgSeason
// @Tags OrgSeason
// @Accept application/json
// @Product application/json
// @Param data body dto.OrgSeasonInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/org-season [post]
// @Security Bearer
func (e OrgSeason) Insert(c *gin.Context) {
    req := dto.OrgSeasonInsertReq{}
    s := service.OrgSeason{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建OrgSeason  失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改OrgSeason
// @Summary 修改OrgSeason
// @Description 修改OrgSeason
// @Tags OrgSeason
// @Accept application/json
// @Product application/json
// @Param data body dto.OrgSeasonUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/org-season/{id} [put]
// @Security Bearer
func (e OrgSeason) Update(c *gin.Context) {
    req := dto.OrgSeasonUpdateReq{}
    s := service.OrgSeason{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改OrgSeason 失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除OrgSeason
// @Summary 删除OrgSeason
// @Description 删除OrgSeason
// @Tags OrgSeason
// @Param ids body []int false "ids"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/org-season [delete]
// @Security Bearer
func (e OrgSeason) Delete(c *gin.Context) {
    s := service.OrgSeason{}
    req := dto.OrgSeasonDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除OrgSeason失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}